/************************************************************************************************/
/**
* @file               common.c
* @author             MCU Ecosystem Development Team
* @brief              通用函数或本外设相关的配置实现函数。
*
*
**************************************************************************************************
* @attention
* Copyright (c) CEC Huada Electronic Design Co.,Ltd. All rights reserved.
*
**************************************************************************************************
*/

/*------------------------------------------includes--------------------------------------------*/
#include "common.h"

/*-------------------------------------------functions------------------------------------------*/

/**
* @brief  系统时钟配置
* @retval 无
*/
void system_clock_config(void)
{
    uint32_t ahbdiv_tmp;
    
    /* 设置Flash读访问等待时间 */
    std_flash_set_latency(FLASH_LATENCY_1CLK);

    /* 使能RCH */
    std_rcc_rch_enable();
    while(!std_rcc_get_rch_ready());
    
    /* 备份AHB分频参数 */
    ahbdiv_tmp = std_rcc_get_ahbdiv();    
    /* 配置AHB最大分频：128分频 */
    std_rcc_set_ahbdiv(RCC_HCLK_DIV128);  
    
    /* 切换RCH4到RCH48 */    
    std_rcc_set_rch_source(RCC_RCH_FREQ_48M);
    
    /* 恢复AHB分频参数 */
    std_rcc_set_ahbdiv(ahbdiv_tmp);      

    /* 设置系统时钟源为RCH */
    std_rcc_set_sysclk_source(RCC_SYSCLK_SRC_RCH);
    while(std_rcc_get_sysclk_source() != RCC_SYSCLK_SRC_STATUS_RCH);

    /* 设置AHB分频因子 */
    std_rcc_set_ahbdiv(RCC_HCLK_DIV1);
    /* 设置APB分频因子 */
    std_rcc_set_apbdiv(RCC_PCLK_DIV1);
    
    SystemCoreClockUpdate(); 
}

/**
* @brief  NVIC初始化
* @retval 无
*/
void nvic_init(void)
{
    /* 配置LPUART中断优先级以及使能LPUART的NVIC中断 */   
    NVIC_SetPriority(LPUART1_IRQn,NVIC_PRIO_1);    
    NVIC_EnableIRQ(LPUART1_IRQn);
}

/**
* @brief  GPIO初始化
* @retval 无
*/
void gpio_init(void)
{
    std_gpio_init_t tmp_gpio_cfg = {0}; 
    
    /* LPUART1 GPIO引脚配置    
       PA9     ------> LPUART1 TX
       PA10    ------> LPUART1 RX
    */    
    std_rcc_gpio_clk_enable(RCC_PERIPH_CLK_GPIOA);
    tmp_gpio_cfg.pin = GPIO_PIN_9 | GPIO_PIN_10;
    tmp_gpio_cfg.mode = GPIO_MODE_ALTERNATE;
    tmp_gpio_cfg.output_type = GPIO_OUTPUT_PUSHPULL;
    tmp_gpio_cfg.pull = GPIO_PULLUP;
    tmp_gpio_cfg.alternate = GPIO_AF5_LPUART1;
    std_gpio_init(GPIOA, &tmp_gpio_cfg);    
}

/**
* @brief  LPUART初始化配置，时钟源为RCH
* @retval 无
*/
void lpuart_init(void)
{
    std_lpuart_init_t lpuart_config = {0};
    
    /* 配置LPUART 时钟源为RCH，选择RCH48时9600波特率需要配置presc分频，本示例配置2分频 */
    std_rcc_set_lpuart1clk_source(RCC_LPUART1_ASYNC_CLK_SRC_RCH);
    
    /* 配置LPUART 外设时钟 */
    std_rcc_apb1_clk_enable(RCC_PERIPH_CLK_LPUART1);

    /* LPUART 模块初始化 */
    lpuart_config.prescaler = LPUART_PRESCALER_DIV2;
    lpuart_config.baudrate = 9600;
    lpuart_config.parity = LPUART_PARITY_NONE;
    lpuart_config.stopbits = LPUART_STOPBITS_1;
    lpuart_config.wordlength = LPUART_WORDLENGTH_8BITS;
    lpuart_config.direction = LPUART_DIRECTION_SEND_RECEIVE;
    /* LPUART 初始化 */
    if (STD_OK != std_lpuart_init(LPUART1,&lpuart_config))
    {
        /* 波特率配置不正确处理代码 */
        while(1);
    } 
}



